﻿using System.IO.MemoryMappedFiles;
using System.Net.Http.Headers;

namespace Šestý
{
    internal class Program
    {
        const int počet = 10;
        const string jméno = "data.dta";
        private static void ZapišBinárně(string jméno)
        {
            using (BinaryWriter zapisovač = new BinaryWriter(new FileStream(jméno, FileMode.Create, FileAccess.Write)))
            {
                zapisovač.Write(0x12345679);
                for (int i = 0; i < počet; i++)
                {
                    zapisovač.Write(i);
                }
            }
        }

        private static void ZapišBinárně1(string jméno)
        {
            FileStream? podklad = null;
            BinaryWriter? zapisovač = null;
            try
            {
                podklad = new FileStream(jméno, FileMode.Create, FileAccess.Write);
                zapisovač = new BinaryWriter(podklad);
                zapisovač.Write(0x12345678);
                for (int i = 0; i < počet; i++)
                {
                    zapisovač.Write(i);
                }
            }
            finally
            {
                zapisovač?.Close();
            }
        }

        private static void PřipišNaKonec(string jméno)
        {
            using (BinaryWriter zapisovač = new BinaryWriter(new FileStream(jméno, FileMode.Append, FileAccess.Write)))
            {
                for (int i = počet; i < 2 * počet; i++)
                {
                    zapisovač.Write(i);
                }
            }
        }

        private static void ČtiBinárně(string jméno)
        {
            using (BinaryReader čtečka = new BinaryReader(new FileStream(jméno, FileMode.Open, FileAccess.Read)))
            {
                while (čtečka.BaseStream.Position < čtečka.BaseStream.Length)
                {
                    int i = čtečka.ReadInt32();
                    Console.WriteLine(i);
                }
            }
        }

        private static void Aktualizuj(string jméno)
        {
            using (FileStream podklad = new FileStream(jméno, FileMode.Open, FileAccess.ReadWrite))
            using (BinaryWriter zapisovač = new BinaryWriter(podklad))
            using (BinaryReader čtečka = new BinaryReader(podklad))
            {
                while (podklad.Position < podklad.Length)
                {
                    int pozice = (int)podklad.Position;
                    int i = čtečka.ReadInt32();
                    if (i % 2 == 0)
                    {
                        i /= 2;
                        zapisovač.Seek(pozice, SeekOrigin.Begin);
                        zapisovač.Write(i);
                    }
                }
            }
        }

        private static void AktualizujVPaměti(string jméno)
        {
            using var soubor = MemoryMappedFile.CreateFromFile(jméno);
            using var přístup = soubor.CreateViewAccessor();
            for (int i = 0; i < 11; i++)
            {
                int hodnota = přístup.ReadInt32(i * 4);
                přístup.Write(i * 4, hodnota + 1);
            }
        }
        static void Main(string[] args)
        {
            //ZapišBinárně(jméno);
            //ZapišBinárně1(jméno);
            //PřipišNaKonec(jméno);
            //ČtiBinárně(jméno);
            //Console.WriteLine("---");
            //Aktualizuj(jméno);
            ČtiBinárně(jméno);
            Console.WriteLine("---");
            AktualizujVPaměti(jméno);
            ČtiBinárně(jméno);
        }
    }
}
