﻿namespace Třetí
{
    struct Komplex
    {
        public double Re { get; set; }
        public double Im { get; set; }
        public Komplex(double re, double im = 0)
        {
            Re = re;
            Im = im;
        }
        public override string ToString()
        {
            return Re + " + " + Im + "i";
        }
        public static Komplex operator-(Komplex z)
        {
            return new Komplex(-z.Re, -z.Im);
        }
        public static Komplex operator+(Komplex z1, Komplex z2)
        {
            return new Komplex(z1.Re + z2.Re, z1.Im + z2.Im);
        }

        public static bool operator==(Komplex z1, Komplex z2)
        {
            return ((z1.Re == z2.Re) && (z1.Im == z2.Im));
        }
        public static bool operator !=(Komplex z1, Komplex z2)
        {
            return !(z1 == z2);
        }

        public static implicit operator Komplex(double x) { return new Komplex(x); }
        public static explicit operator double(Komplex z)
        {
            if (z.Im == 0) return z.Re;
            else throw new ArgumentOutOfRangeException("Imaginární část není nulová");
        }

        public double this[int i]
        {
            get => i switch { 1 => Re, 2 => Im, _ => throw new ArgumentOutOfRangeException("Index mimo meze") };
            set
            {
                switch(i)
                {
                    case 1: 
                        Re = value;
                        break;
                    case 2:
                        Im = value;
                        break;
                    default:
                        throw new ArgumentOutOfRangeException("Index mimo meze");
                }
            }
        }
    }
    internal class Program
    {
        static void Main(string[] args)
        {
            Komplex z = -new Komplex(1,1);
            Komplex z2 = new Komplex(2,3);
            z += z2;
            Console.WriteLine(z + z2); ;
            if (z == z2) { }
            //z = 11;
            //double x = (double)z;
            Console.WriteLine(z[1]);
        }
    }
}
